﻿//【登録場所】 "V2C\script\system\threadld.js"
//【内容】threadld.jsのまとめ
//【備考】threadUpdatedとpanelCreatedの{}内で、行頭のコメント「//」を、利用する行ごとに解除することで、有効になります。
//【更新日】2013/01/27
//【スクリプト】
// ----- 次の行から -----
/* スレッドの更新が完了した時に実行するスクリプト */
function threadUpdated(th, cx) {
/* 機能を有効にしたい場合、下の各行頭//を削除してください  */
//  egnoreNewNGRes(th, cx); //新着がNGのみの場合、未読状態を解除
//  redirectNewsThread(th, cx); //速報headlineスレを開くと本スレにリダイレクト ※パーミッションにSを追加してください ※速報headlineスレのログは削除されません。
//  redirectLiveThread(th, cx); //テレビ番組欄のスレを開くと一番勢いのあるスレッド(恐らく本スレ)にリダイレクト ※パーミッションにSを追加してください ※テレビ番組欄スレのログは削除されません。
//  idConditionalNG(th, cx); //閾値以上書き込みIDをNG判定(デフォルトはニュー速と嫌儲で有効)
//  checkNewTanpatsuNG(th, cx); //新着レスを対象に単発IDのレスを非表示にする。（デフォルトは実況カテゴリで有効）
}

/* レス表示タブを作成した時に実行するスクリプト */
function panelCreated(th) {
/* 機能を有効にしたい場合、下の各行頭//を削除してください  */
//  openWritePanel(th); //開いたスレが2chの場合、書き込みパネルを自動で開く
//  openFixedColumn(th); //常に特定のカラムで開く（デフォルトは0カラム）
//  groupThreadPanel(th); //2カラムの状態で、特定の板（デフォルトは実況カテゴリとTwitter）を特定のカラム（デフォルトは0カラム）で開く
}

/* 関数名を添えてスクリプトコンソール出力
使用例 printFunc(arguments.callee, "要素１は「{0}」です。", 100); */
function printFunc(func, format /*, ...*/)
{
  var args = arguments;
  var message = format.replace(/\{(\d)\}/g, function(m, c) { return args[parseInt(c) + 2]; });

  if (func && (typeof func == 'function')) {
    v2c.println("[threadld.js : " + func.name + "()] " + message);
  } else {
    v2c.println("[threadld.js]" + message);
  }
}

/* ここから各機能 */
function egnoreNewNGRes(th, cx) {
  var newResi = th.localResCount - cx.numNewRes;
  for (var i = newResi; i < th.localResCount; i++) {
    var res = th.getRes(i);
    if (res && !res.ng) {
      return;
    }
  }
  th.resetUnread();
}

function redirectLiveThread(th, cx) {
// ―┤設定項目ここから├―――――――――――――――――――――――――――――――――――――――――――
  // [設定項目] スレタイから番組名を除外した部分を対象に以下の正規表現でマッチした場合除外する。
  var DENY_WORDS = new RegExp("(ﾏﾀｰﾘ|マターリ|酒|sage)", "i");
  // [設定項目] スレと一緒に板一覧を開く場合はture開かない場合はfalse
  var BOARDVIEW = true;
  // [設定項目] スクリプトコンソールに比較文字列を出力する(一致具合検証用) 出力する場合はtrueしない場合はfalse
  var OUTPUT_COMPARE = false;
  // [設定項目] 番組名とスレタイに比較前に補正を掛けて一致しやすくする
  var PRE_FUNC = (function(name) {
    //カッコを削除(DEBY_WORDSの場合は残す
    if (!DENY_WORDS.test(name)) {
      name = name.replace(/[\[\(\<【（｛＜［《〔][^\]\)\>】）｝」』＞］》〕]+[\]\)\>】）｝＞］》〕]/g, ''); // カッコの種類の「『 はタイトルに使われる場合があるので除外
    }
    //全角英数字を半角に
    name = name.replace(/[！-～]/g, function(s) {
      return String.fromCharCode(s.charCodeAt(0) - 0xFEE0);
    });
    //半角英数字をと日本語以外は削除。小文字を大文字に
    name = name.replace(/[^一-龠ぁ-んァ-ヴa-zA-Z0-9\r\n]/ig, '').toUpperCase();

    var hanKana = ['ｶﾞ', 'ｷﾞ', 'ｸﾞ', 'ｹﾞ', 'ｺﾞ', 'ｻﾞ', 'ｼﾞ', 'ｽﾞ', 'ｾﾞ', 'ｿﾞ', 'ﾀﾞ', 'ﾁﾞ', 'ﾂﾞ', 'ﾃﾞ', 'ﾄﾞ', 'ﾊﾞ', 'ﾊﾟ', 'ﾋﾞ', 'ﾋﾟ', 'ﾌﾞ', 'ﾌﾟ', 'ﾍﾞ', 'ﾍﾟ', 'ﾎﾞ', 'ﾎﾟ', 'ｳﾞ',
    'ｧ', 'ｱ', 'ｨ', 'ｲ', 'ｩ', 'ｳ', 'ｪ', 'ｴ', 'ｫ', 'ｵ', 'ｶ', 'ｷ', 'ｸ', 'ｹ', 'ｺ', 'ｻ', 'ｼ', 'ｽ', 'ｾ', 'ｿ', 'ﾀ', 'ﾁ', 'ｯ', 'ﾂ', 'ﾃ', 'ﾄ', 'ﾅ', 'ﾆ', 'ﾇ', 'ﾈ', 'ﾉ', 'ﾊ', 'ﾋ', 'ﾌ', 'ﾍ',
    'ﾎ', 'ﾏ', 'ﾐ', 'ﾑ', 'ﾒ', 'ﾓ', 'ｬ', 'ﾔ', 'ｭ', 'ﾕ', 'ｮ', 'ﾖ', 'ﾗ', 'ﾘ', 'ﾙ', 'ﾚ', 'ﾛ', 'ﾜ', 'ﾜ', 'ｦ', 'ﾝ', '｡', '｢', '｣', '､', '･', 'ｰ', 'ﾞ', 'ﾟ'];
    var zenKana = 'ガギグゲゴザジズゼゾダヂヅデドバパビピブプベペボポヴァアィイゥウェエォオカキクケコサシスセソタチッツテトナニヌネノハヒフヘホマミムメモャヤュユョヨラリルレロワワヲン。「」、・ー゛゜';
    var zenHira = 'がぎぐげござじずぜぞだぢづでどばぱびぴぶぷべぺぼぽゔぁあぃいぅうぇえぉおかきくけこさしすせそたちっつてとなにぬねのはひふへほまみむめもゃやゅゆょよらりるれろわわをん。「」、・ー゛゜';
    //全角カタカナひらがなを半角カタカナに
    name = name.replace(/[ぁ-んァ-ヴ「」、・ー゛゜]/g, function(s) {
      var n = zenKana.indexOf(s);
      if (n != -1) { return hanKana[n]; }
      n = zenHira.indexOf(s);
      if (n != -1) { return hanKana[n]; }
      return '';
    });
    return name;
  });
// ――――――――――――――――――――――――――――――――――――――――――――――――――――――

  if (!cx.error && th.board.key.startsWith('tv2chwiki')) {
    var tmp = th.getRes(0);
    var bd = v2c.getBoard(tmp.links[0]);
    if (!bd) { printFunc(arguments.callee, "{0}の取得に失敗", bd); return false; }
    tmp = String(tmp.message).split('\n');
    if ((!tmp) || tmp.length <= 0) { printFunc(arguments.callee, "{0}の>>1の本文の取得に失敗", th); return false; }
    // ヒット率を上げるために全角スペースで区切ってループ判定（その分誤判定も増える。元のロジックに戻した場合は見つからなかったで終わり）
    var rawtitle = tmp[1];
    var rawtitleArray = rawtitle.split('　').reverse();
    if (rawtitleArray.length < 2 || rawtitleArray[0].indexOf('res/min') == -1) {
      printFunc(arguments.callee, "{0}の>>1の本文から番組名を取得できませんでした。", th); return false;
    }
    rawtitleArray.shift();
    var ss = v2c.readURL(bd.url + 'subject.txt');
    if (v2c.interrupted) { return false; }
    if (!ss) { printFunc(arguments.callee, "{0}の取得に失敗", bd); return false; }
    var lines = ss.split('\n');
    var now = Math.floor((new Date()).getTime() / 1000);
    var max = {speed: 0, key: '', title: '', resnum: ''};
    printFunc(arguments.callee, "【リダイレクト先の検索開始】番組名：{0}", rawtitle);
    for (var rtacnt = 0; rtacnt < rawtitleArray.length; rtacnt++) {
      var title = PRE_FUNC(rawtitleArray[rtacnt]);
      for (var i = 0; i < lines.length; i++) {
        if (/^(\d+)\.dat<>(.+) \((\d+)\)/.test(lines[i])) {
          var current = RegExp.$1;
          var name = RegExp.$2;
          var resnum = RegExp.$3;
          var speed = parseInt(resnum) / ((now - parseInt(current)) / 86400)
          tmp = PRE_FUNC(name);
          if (OUTPUT_COMPARE) {
            v2c.println(title + '\t=\t' + tmp);
          }
          var idx = tmp.indexOf(title);
          if (idx >= 0) {
            if (DENY_WORDS.test(tmp.substring(0, idx)) || DENY_WORDS.test(tmp.substring(idx + title.length))) { 
              printFunc(arguments.callee, "DENY_WORDS「{1}」にヒットしたので「{0}」を除外します。", RegExp.$1, name);
              continue;
            }
            if (speed > max.speed) {
              max.speed = speed;
              max.key = current;
              max.title = name;
              max.resnum = parseInt(resnum);
            }
          }
        }
      }
      if (max.key && max.key.length > 0) {
        break;
      }
    }
    if (max.key && max.key.length > 0) {
      printFunc(arguments.callee, "【検索終了。スレッドの取得を試みます】スレタイ名：{0} ", max.title);
      if (BOARDVIEW) {
        v2c.openURL(bd.url);
        var th2 = bd.getThread(max.key, bd.url, max.title, max.resnum);
        if (th2) {
          th2.updateAndWait();
          th2.open(false, false, false);
        } else {
          printFunc(arguments.callee, "最も勢いのあるスレッド key = {0} が開けませんでした。", max.key);
        }
      } else {
        var th2 = bd.getThread(max.key);
        if (!th2) { 
          printFunc(arguments.callee, "最も勢いのあるスレッド key = {0} の取得に失敗したのでスレ一覧を開きました", max.key);
          v2c.openURL(bd.url);
        } else {
          th2.open(true, false, false);
        }
      }
    } else {
      printFunc(arguments.callee, "【スレッドを見つけられなかったのでスレ一覧を開きます】番組名 : {0}", rawtitle);
      v2c.openURL(bd.url);
    }
  }
}
function redirectNewsThread(th, cx) {
  if (!cx.error && th.board.key.match(/(bbynews|bbylive|bbynamazu|bbylunch)/)) {
    var u = th.getRes(1).links[0];
    v2c.openURL(u,true,false,false);
  }
}
function openWritePanel(th) {
  if (
      th.bbs.is2ch
      /* 2ｃｈ以外でも有効にしたい場合、下の各行頭//を削除してください  */
      //  || th.bbs.is2cheq　//BBSが2ch互換板の場合
      //  || th.bbs.shitaraba　//BBSがしたらばの場合
      //  || th.bbs.machi　//BBSがまちBBSの場合
      //  || th.bbs.twitter　//BBSがTwitterの場合
      ) {
    th.mayOpenWritePanel();
  }
}
// 対象文字列のチェック
function checkThStr(str, target) {
  var tlen, i;
  if ((tlen = target.length) > 0) {
    for (i=0; i<tlen; i++) {
      if (str.indexOf(target[i]) > -1) {
        return true;
      }
    }
  }
  return false;
}

// IDのNG判定
function idConditionalNG(th, cx) {
  /* 設定 */
  // idCountがこの値を超えたらそのIDをNG 初期値20
  var threshold = 20;
  // trueなら透明NGID、falseなら通常NGID
  var set_t = false;
  // IDの長さがこの値を超えたらチェック対象にする
  var inflen = 7;
  // 実行する対象URL、スレURLに含まれるか(th.url.toString().indexOf() > 0)を
  // チェックするので ".2ch.net/test/read.cgi/news/" という風に
  // 複数あるときは , で区切る
  // 2chすべての板を対象にするなら ".2ch.net/test/read.cgi/" など
  // すべてを対象にするなら "." など
  // ↓は既にニュー速と嫌儲を登録、必要ないなら削除
  var target = [
    ".2ch.net/test/read.cgi/news/",
    ".2ch.net/test/read.cgi/poverty/",
  ];
  /* 設定終わり */

  if(!cx.error && cx.numNewRes > 0 && checkThStr(th.url.toString(), target)) {
    var srtnum = th.localResCount - cx.numNewRes;
    var res, i;
    var rflag = false;
    for (i=srtnum; i<th.localResCount; i++) {
      res = th.getRes(i);
      if (res != null && !res.ng && res.id && res.id.length() > inflen && res.idCount > threshold) {
        res.addNGID(set_t);
        rflag = true;
      }
    }
    // 追加があったら再チェック
    if (rflag) {
      v2c.resPane.checkNG(th);// ←重いようならth.boardをthにしてそのスレだけで再チェック
    }
  }
}
// 新着レスを対象に単発IDのレスを非表示にする。
// 既にNGとなっている場合はNGラベルの見分けがつくように何もしない。
// [through]
//   単発でもスルーするレスの範囲（through=50で>>1-50のレスを飛ばす。）
function setNewTanpatsuNG(th, cx, through) {
  var lrc = th.localResCount
  var format = '非表示の単発IDｽｶｳﾀｰ: '
  var scouter = 0

  for ( var i = lrc - cx.numNewRes; i < lrc; i++ ) {
    if ( i < through ) continue;

    var res = th.getRes( i )
    if ( res && res.idCount == 1 && !res.ng ) {
      res.setNGRes()
      scouter++
      v2c.setStatus( format + scouter )
    }
  }
}
function checkNewTanpatsuNG( th, cx ) {
  var target = [ //実況カテゴリ
    'live',
    'endless',
    'weekly',
    'kokkai',
    'dome',
    'oonna',
    'ootoko',
    'dancesite',
    'festival',
    'jasmine',
  ];
  var targetTanpatsu = /Firefox|Google/i

  if ( cx.numNewRes > 0 ) {
    if ( th.bbs.is2ch && checkThStr(th.board.key, target) ) {
      setNewTanpatsuNG( th, cx, 75 );
    } else if ( targetTanpatsu.test( th.title ) ) {
      setNewTanpatsuNG( th, cx,  1 );
    }
    egnoreNewNGRes( th, cx )
  }
}

function openFixedColumn(th) {
  /* 設定 */
  var index = 0;//スレッド開くときに常に使用するカラムIndex
  /* 設定ここまで */
  
  if (th.columnIndex>index) {
    th.movePanelTo(index, -1);
    th.open(false, false, false);//移動した後表示
  }
}
function groupThreadPanel(th) {
  /* 設定 */
  var target = [ //実況カテゴリ
    'live',
    'endless',
    'weekly',
    'kokkai',
    'dome',
    'oonna',
    'ootoko',
    'dancesite',
    'festival',
    'jasmine',
  ];
  var targetIndex = 0;//target1の場合に開くColumnIndex
  var otherIndex = 1;//target以外で開くColumnIndex
  /* 設定ここまで */

  if (th.bbs.is2ch && checkThStr(th.board.key, target) || th.bbs.twitter) {
    if (th.columnIndex != targetIndex) {
      th.movePanelTo(targetIndex, -1);
      th.open(false, false, false);//移動した後表示
    }
  } else {
    if (th.columnIndex != otherIndex) {
      th.movePanelTo(otherIndex, -1);
      th.open(false, false, false);//移動した後表示
    }
  }
  
}
